> ## Documentation Index
> Fetch the complete documentation index at: https://docs.waffo.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# グループの更新

> 商品グループの名前、説明、ルール、または商品リストを更新する

商品グループの名前、説明、ルール、または商品リストを更新します。

```
POST /v1/actions/subscription-product-group/update-group
```

**認証：** API Key

## リクエストボディ

| フィールド         | 型         | 必須  | 説明                                            |
| ------------- | --------- | --- | --------------------------------------------- |
| `id`          | string    | Yes | グループ ID（UUID フォーマット）                          |
| `name`        | string    | No  | 更新後のグループ名                                     |
| `description` | string    | No  | 更新後の説明                                        |
| `rules`       | object    | No  | 更新後のルール（`{ sharedTrial: boolean }`）           |
| `productIds`  | string\[] | No  | 更新後の商品リスト（`PROD_xxx` フォーマット）。**リスト全体を置換します。** |

## リクエスト例

<CodeGroup>
  ```typescript SDK theme={"system"}
  const { group } = await client.subscriptionProductGroups.update({
    id: "d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f9a",
    name: "Updated Pricing Plans",
    productIds: [
      "PROD_3F7H2J5L8N1Q4S6U",
      "PROD_8B4D6F9H2K5M7P1R",
    ],
  });
  ```

  ```typescript TypeScript (fetch) theme={"system"}
  // Uses callApi() helper from authentication.mdx
  const result = await callApi("POST", "/v1/actions/subscription-product-group/update-group", {
    id: "d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f9a",
    name: "Updated Pricing Plans",
    productIds: [
      "PROD_3F7H2J5L8N1Q4S6U",
      "PROD_8B4D6F9H2K5M7P1R",
    ],
  });
  console.log(result.data);
  ```

  ```java Java theme={"system"}
  // Uses callApi() helper from authentication.mdx
  String body = """
      {"id":"d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f9a","name":"Updated Pricing Plans","productIds":["PROD_3F7H2J5L8N1Q4S6U","PROD_8B4D6F9H2K5M7P1R"]}""";

  String response = callApi("POST", "/v1/actions/subscription-product-group/update-group", body);
  System.out.println(response);
  ```

  ```python Python theme={"system"}
  # Uses call_api() helper from authentication.mdx
  result = call_api("POST", "/v1/actions/subscription-product-group/update-group", {
      "id": "d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f9a",
      "name": "Updated Pricing Plans",
      "productIds": [
          "PROD_3F7H2J5L8N1Q4S6U",
          "PROD_8B4D6F9H2K5M7P1R",
      ],
  })
  print(result["data"])
  ```

  ```go Go theme={"system"}
  // Uses callAPI() helper from authentication.mdx
  body := map[string]interface{}{
      "id":   "d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f9a",
      "name": "Updated Pricing Plans",
      "productIds": []string{
          "PROD_3F7H2J5L8N1Q4S6U",
          "PROD_8B4D6F9H2K5M7P1R",
      },
  }
  result, err := callAPI("POST", "/v1/actions/subscription-product-group/update-group", body)
  if err != nil {
      log.Fatal(err)
  }
  fmt.Println(string(result))
  ```

  ```rust Rust theme={"system"}
  // Uses call_api() helper from authentication.mdx
  let body = serde_json::json!({
      "id": "d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f9a",
      "name": "Updated Pricing Plans",
      "productIds": [
          "PROD_3F7H2J5L8N1Q4S6U",
          "PROD_8B4D6F9H2K5M7P1R"
      ]
  });
  let result = call_api("POST", "/v1/actions/subscription-product-group/update-group", &body).await?;
  println!("{}", result);
  ```

  ```c C theme={"system"}
  /* Uses call_api() helper from authentication.mdx */
  const char *body = "{\"id\":\"d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f9a\",\"name\":\"Updated Pricing Plans\",\"productIds\":[\"PROD_3F7H2J5L8N1Q4S6U\",\"PROD_8B4D6F9H2K5M7P1R\"]}";
  char *response = call_api("POST", "/v1/actions/subscription-product-group/update-group", body);
  printf("%s\n", response);
  free(response);
  ```

  ```cpp C++ theme={"system"}
  // Uses callApi() helper from authentication.mdx
  std::string body = R"({"id":"d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f9a","name":"Updated Pricing Plans","productIds":["PROD_3F7H2J5L8N1Q4S6U","PROD_8B4D6F9H2K5M7P1R"]})";
  std::string response = callApi("POST", "/v1/actions/subscription-product-group/update-group", body);
  std::cout << response << std::endl;
  ```

  ```bash cURL theme={"system"}
  MERCHANT_ID="MER_2aUyqjCzEIiEcYMKj7TZtw"
  TIMESTAMP=$(date +%s)
  BODY='{
    "id": "d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f9a",
    "name": "Updated Pricing Plans",
    "productIds": [
      "PROD_3F7H2J5L8N1Q4S6U",
      "PROD_8B4D6F9H2K5M7P1R"
    ]
  }'
  BODY_HASH=$(echo -n "$BODY" | openssl dgst -sha256 -binary | base64 -w 0)
  CANONICAL_REQUEST="POST
  /v1/actions/subscription-product-group/update-group
  $TIMESTAMP
  $BODY_HASH"

  SIGNATURE=$(echo -n "$CANONICAL_REQUEST" | openssl dgst -sha256 -sign private_key.pem | base64 -w 0)

  curl -X POST "https://api.waffo.ai/v1/actions/subscription-product-group/update-group" \
    -H "Content-Type: application/json" \
    -H "X-Merchant-Id: $MERCHANT_ID" \
    -H "X-Timestamp: $TIMESTAMP" \
    -H "X-Signature: $SIGNATURE" \
    -d "$BODY"
  ```

  ```bash wget theme={"system"}
  MERCHANT_ID="MER_2aUyqjCzEIiEcYMKj7TZtw"
  TIMESTAMP=$(date +%s)
  BODY='{
    "id": "d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f9a",
    "name": "Updated Pricing Plans",
    "productIds": [
      "PROD_3F7H2J5L8N1Q4S6U",
      "PROD_8B4D6F9H2K5M7P1R"
    ]
  }'
  BODY_HASH=$(echo -n "$BODY" | openssl dgst -sha256 -binary | base64 -w 0)
  CANONICAL_REQUEST="POST
  /v1/actions/subscription-product-group/update-group
  $TIMESTAMP
  $BODY_HASH"

  SIGNATURE=$(echo -n "$CANONICAL_REQUEST" | openssl dgst -sha256 -sign private_key.pem | base64 -w 0)

  wget -qO- "https://api.waffo.ai/v1/actions/subscription-product-group/update-group" \
    --header="Content-Type: application/json" \
    --header="X-Merchant-Id: $MERCHANT_ID" \
    --header="X-Timestamp: $TIMESTAMP" \
    --header="X-Signature: $SIGNATURE" \
    --post-data="$BODY"
  ```
</CodeGroup>

<Warning>
  `productIds` フィールドは**商品リスト全体を置換します**。商品を追加するには、既存の商品 ID すべてと新しい ID を含めてください。商品を削除するには、リストから省略してください。
</Warning>

## エラー

> **リトライポリシー**：4xx は一切リトライしない — リクエストを修正してから再送信。5xx は指数バックオフでリトライ（5s 開始、最大 3 回）。

| ステータス | `errors[0].message`                    | 意味                                | 推奨処理                       |
| ----- | -------------------------------------- | --------------------------------- | -------------------------- |
| 400   | `Missing required field: id`           | リクエストボディに `id` が含まれない             | `id` を追加して再送信              |
| 400   | `Expected format: PROD_xxx, got "..."` | `productIds` の Short ID をデコードできない | ID を修正して再送信                |
| 404   | `Group not found`                      | 指定された `id` のグループが存在しない            | `id` が自分のストアに属しているか確認      |
| 500   | `Internal server error`                | 内部エラーまたは一時的な下流障害                  | 指数バックオフでリトライ（5s 開始、最大 3 回） |
